
function wenner2lay_fit

clear all
close all

% Define initial model
z=1;
rho1 =100;
rho2 = 100;

load malagash.txt

for m =1:18
  adat(m)      = malagash(m,1);
  apprhodat(m) = malagash(m,2);
end

% Covert a-spacing into metres
adat =adat/3.28;
iset=0
for loga =-1.:0.1:4.5
  iset=iset+1;
  a(iset) =10.^(loga);
end

irun =1
while irun ~= -1
            
   k=(rho2-rho1)/(rho1+rho2)
       
% For given model compute apparent resistivity with infinite sum    
    
    for ispace =1:length(a)
      dw=0;
      for m=1 : 200
         f= (2.*m*z)/a(ispace);
        f2 = f*f;
        km = (k.^m);   
        d =km* ((1./(sqrt(1.+f2)))-(1./(sqrt(4.+f2))));
        icount(m) =m;
        dwm(m)=d;
        dw=dw+d;
        sum(m)=dw;
      end
      rho(ispace) = rho1*(1.+4.*dw);

  end
  % end of 'a' loop    
  
  
  % Plot the fit to the measured data
  subplot(2,1,1)
  loglog(a,rho,'b-') 
  hold on  
  loglog(adat,apprhodat,'bo')
  hold off
  axis([0.1, 100000, 1, 300])
  xlabel('a(m)')
  ylabel('apparent resistivity (ohm.m)')
  text(1000,30,'Fit to measured data')

  rhoplot(1) = rho1
  dplot  (1) = 0.1
  rhoplot(2) = rho1
  dplot  (2) = z
  rhoplot(3) = rho2
  dplot  (3) = z
  rhoplot(4) = rho2
  dplot  (4) = 100000
  
% Plot resistivity model
  subplot(2,1,2)
  loglog (dplot,rhoplot,'b-')
  axis([0.1, 100000, 1., 300])
  xlabel('depth(m)')
  ylabel('resistivity (ohm.m)')
  text(1000,30,'Resistivity model')

  
    
 % Change these parameters to get a better fit 
 choice=menu('Options', 'Change rho1','Change z', 'Change rho2','Print result and quit')
 if choice ==1  
   rho1
   rho1=input('Enter rho1:')
 end
   
 if choice ==2
   z
   z=input('Enter z (m):')
 end
   
 if choice ==3
   rho2
   rho2=input('Enter rho2:')  
 end
   
 if choice ==4
    close all
    
    subplot(2,1,1)
    loglog(a,rho,'b-') 
    hold on  
    loglog(adat,apprhodat,'bo')
    hold off
    axis([0.1, 100000, 1, 300])
    xlabel('a(m)')
    ylabel('apparent resistivity (ohm.m)')
    text(1000,30,'Fit to measured data')

    subplot(2,1,2)
    loglog (dplot,rhoplot,'b-')
    axis([0.1, 100000, 1., 300])
    xlabel('depth(m)')
    ylabel('resistivity (ohm.m)')
    text(1000,30,'Resistivity model')
       
    print -dpsc  fit.ps
    irun = -1   
  end
  
end